#ifndef __AUTOMATA_H__
#define __AUTOMATA_H__

#include <gdk/gdk.h>
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
#define AUTOMATA_NEW 0
#define AUTOMATA_CORRECT 1
#define AUTOMATA_SPECIAL 2
#define AUTOMATA_CORRECT_NEW 3
#define AUTOMATA_ERROR 4
#define AUTOMATA_NULL 5

void hangul_input_clear(void);
int  hangul_input_process(char *buf, guint *c);
int  hangul_input_state_get(void);
void hangul_input_state_set(int state);
void hangul_keyboard_set(int keyboard);
int  hangul_keyboard_get(void);
void entry_hangul_input_init(void);
extern void (*hangul_input_state_changed_callback)(void);
int is_first_han(char *buf, int x);
int is_second_han(char *buf, int x);
void convert_ks_to_3(const unsigned char *src, int *f, int *m, int *l);
int convert_3_to_ks(int f, int m, int l, unsigned char *des);
gint hangul_state_toggle_event(GdkEventKey *event);
gint hangul_need_clear(GdkEventKey *event);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __AUTOMATA_H__ */
